'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _App = require('tooey/lib/App');

var _App2 = _interopRequireDefault(_App);

var _Tab = require('tooey/lib/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Connection = require('../model/Connection');

var _Connection2 = _interopRequireDefault(_Connection);

var _NetworkSelection = require('./views/NetworkSelection');

var _NetworkSelection2 = _interopRequireDefault(_NetworkSelection);

var _ConnectionHistory = require('./views/ConnectionHistory');

var _ConnectionHistory2 = _interopRequireDefault(_ConnectionHistory);

var _package = require('../../package.json');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const makeInitialView = tab => {
  let result;
  // Render starting view
  if (_Connection2.default.getHistory().length) {
    result = new _ConnectionHistory2.default(tab);
  } else {
    result = new _NetworkSelection2.default(tab);
  }
  return result;
};


const app = new _App2.default(`Cashtui v${_package.version}`, makeInitialView);
exports.default = app;