'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _List = require('tooey/lib/List');

var _List2 = _interopRequireDefault(_List);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Generic single column list view with standard menu */
class GenericList extends _ViewBase2.default {

  constructor(title, data) {
    super(title);

    this._menu = new _Menu2.default(_app2.default.activeTab);

    const columns = [{
      heading: 'Result',
      width: 999,
      value: row => row
    }];
    this._list = new _List2.default(_app2.default.activeTab, columns, data, {
      dataMapper: rec => [rec],
      showHeadings: false,
      menu: this._menu
    });
  }

  render() {
    // Render list first
    this._list.render();

    // Render menu last so cursor position is left in correct position
    this._menu.render(false);
  }

  async handle(key) {
    let handled = false;
    handled = await this._menu.handle(key);
    if (!handled) {
      handled = await this._list.handle(key);
    }
    return handled;
  }
}
exports.default = GenericList;