'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuItem = require('tooey/lib/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Tab = require('tooey/lib/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _TransactionsMenu = require('./TransactionsMenu');

var _TransactionsMenu2 = _interopRequireDefault(_TransactionsMenu);

var _RpcInput = require('./RpcInput');

var _RpcInput2 = _interopRequireDefault(_RpcInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class MainMenu extends _ViewBase2.default {

  constructor(tab) {
    super('Main Menu');
    this._tab = tab;
    this._menu = new _Menu2.default(tab, [new _MenuItem2.default('T', 'Transactions', 'Work with transactions', this.toTransactions.bind(this)), new _MenuItem2.default('R', 'RPC', 'Execute JSON RPC commands', this.toRpc.bind(this))]);
  }

  async toRpc() {
    this._tab.pushView(new _RpcInput2.default());
  }

  async toTransactions() {
    this._tab.pushView(new _TransactionsMenu2.default(this._tab));
  }

  render() {
    this._menu.render(false);
  }

  async handle(key) {
    return this._menu.handle(key);
  }
}
exports.default = MainMenu;