'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Transaction = require('cashlib/lib/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Input = require('tooey/lib/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputHelp = require('tooey/lib/InputHelp');

var _InputHelp2 = _interopRequireDefault(_InputHelp);

var _Tab = require('tooey/lib/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _TransactionHeader = require('./TransactionHeader');

var _TransactionHeader2 = _interopRequireDefault(_TransactionHeader);

var _state = require('../../model/state');

var _state2 = _interopRequireDefault(_state);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class RawTransactionInput extends _ViewBase2.default {

  constructor(tab) {
    super('Enter raw transaction');
    this._tab = tab;
    this._input = new _Input2.default(tab, this.onEnter.bind(this));
    this._inputHelp = new _InputHelp2.default();
  }

  render() {
    this._inputHelp.render();
    this._input.render();
  }

  async handle(key) {
    return this._input.handle(key);
  }

  async onEnter() {
    try {
      _state2.default.transactions.active = _Transaction2.default.deserialize(this._input.value);
      this._tab.replaceView(new _TransactionHeader2.default(this._tab));
    } catch (error) {
      this._tab.setError(error.message);
    }
  }
}
exports.default = RawTransactionInput;