'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Transaction = require('cashlib/lib/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _Output = require('cashlib/lib/Output');

var _Output2 = _interopRequireDefault(_Output);

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuItem = require('tooey/lib/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Tab = require('tooey/lib/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _OutputsList = require('../components/OutputsList');

var _OutputsList2 = _interopRequireDefault(_OutputsList);

var _TransactionOutput = require('./TransactionOutput');

var _TransactionOutput2 = _interopRequireDefault(_TransactionOutput);

var _TransactionAddP2PKH = require('./TransactionAddP2PKH');

var _TransactionAddP2PKH2 = _interopRequireDefault(_TransactionAddP2PKH);

var _state = require('../../model/state');

var _state2 = _interopRequireDefault(_state);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class TransactionOutputs extends _ViewBase2.default {

  constructor(tab) {
    super('Transaction Outputs');
    this._tab = tab;
    const transaction = _state2.default.transactions.active;

    const menuItems = [new _MenuItem2.default('S', 'Show', 'Show details for selected output', this.toDetails.bind(this)), new _MenuItem2.default('A', 'Add P2PKH', 'Add new Pay To Public Key Hash output', async () => tab.pushView(new _TransactionAddP2PKH2.default()))];
    this._menu = new _Menu2.default(tab, menuItems);

    this._list = new _OutputsList2.default(tab, transaction.outputs, this._menu, true);
  }

  async toDetails() {
    const output = _state2.default.transactions.active.outputs[this._list.selectedOutputIndex];
    if (output) {
      this._tab.pushView(new _TransactionOutput2.default(output, _state2.default.transactions.active.getId(), this._list.selectedOutputIndex));
    } else {
      this._tab.setWarning('No output selected');
    }
  }

  getSelectedOutput() {
    const selectedIndex = this._list.selectedOutputIndex;
    return _state2.default.transactions.active.outputs[selectedIndex];
  }

  render() {
    // Render outputs list
    this._list.render();

    // Render menu last for correct cursor positioning
    this._menu.render(false);
  }

  async handle(key) {
    let handled = await this._menu.handle(key);
    if (!handled) {
      handled = await this._list.handle(key);
    }
    return handled;
  }
}
exports.default = TransactionOutputs;