'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cashlib = require('cashlib');

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuItem = require('tooey/lib/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Tab = require('tooey/lib/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _RawTransactionInput = require('./RawTransactionInput');

var _RawTransactionInput2 = _interopRequireDefault(_RawTransactionInput);

var _TransactionIdInput = require('./TransactionIdInput');

var _TransactionIdInput2 = _interopRequireDefault(_TransactionIdInput);

var _state = require('../../model/state');

var _state2 = _interopRequireDefault(_state);

var _TransactionHeader = require('./TransactionHeader');

var _TransactionHeader2 = _interopRequireDefault(_TransactionHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class TransactionsMenu extends _ViewBase2.default {

  constructor(tab) {
    super('Transactions');
    this._tab = tab;

    const items = [new _MenuItem2.default('I', 'By Id', 'Retrieve transaction from full node', this.toTransactionIdInput.bind(this)), new _MenuItem2.default('C', 'Create', 'Create new transaction', this.createTransaction.bind(this)), new _MenuItem2.default('D', 'Decode raw', 'Decode raw transaction', this.toRawTransactionInput.bind(this)), new _MenuItem2.default('R', 'Recent', 'Recent transactions')];
    this._menu = new _Menu2.default(tab, items);
  }

  async toTransactionIdInput() {
    this._tab.pushView(new _TransactionIdInput2.default(this._tab));
  }

  async createTransaction() {
    _state2.default.transactions.active = new _cashlib.Transaction();
    this._tab.pushView(new _TransactionHeader2.default(this._tab));
  }

  async toRawTransactionInput() {
    this._tab.pushView(new _RawTransactionInput2.default(this._tab));
  }

  async handle(key) {
    return this._menu.handle(key);
  }

  render() {
    this._menu.render(false);
  }
}
exports.default = TransactionsMenu;